/*******************************************************************************
 * FoxGameObject_HillPoint generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxGameObject_HillPoint extends FoxStation_Base
    abstract
    native
    config(Game)
    notplaceable
    hidecategories(Navigation);

struct native hillZoneInfo
{
    var array<FoxPRI> PRIs;

    structdefaultproperties
    {
        PRIs=none
    }
};

var() float requiredTimeForCapture;
var() repnotify bool isHillActive;
var repnotify transient bool bCapturable;
var private transient bool coolDownAnimTrigger;
var private repnotify transient bool bIsGameEnd;
var transient bool bAwaitingTeamColor;
var private transient bool bHRVIsEnabled;
var private transient hillZoneInfo whoIsOnTheHillInfo[2];
var private transient hillZoneInfo whoWasOnTheHillInfo[2];
var private repnotify transient int CurrentCapturingTeam;
var private repnotify transient float timeOnHill_team0;
var private repnotify transient float timeOnHill_team1;
var private transient float captureCoolDown;
var private repnotify transient float CountMultiplier;
var private AnimNodeSequence CaptureAnimNode;
var private transient float CaptureAnimTime;
var private export editinline ParticleSystemComponent BeaconPSComp;
var private export editinline ParticleSystemComponent BeaconRingsPSComp;
var private export editinline LensFlareComponent BlinkingAllyLFComp;
var private export editinline LensFlareComponent BlinkingFoeLFComp;
var private export editinline LensFlareComponent AllyCaptLFComp;
var private export editinline LensFlareComponent FoeCaptLFComp;
var private const name CaptureParticleSystemAttachSocketName;
var private repnotify transient name CurrentStateName;
var private const name TeamColorParameterName;
var private const name CaptureAmountParameterName;
var private const name CapturedParticleSystemColorParamName;
var private float CapturedPSFadeTime;
var private const AkEvent StartCaptureEvent;
var private const AkEvent CompleteCaptureEvent;
var private const AkEvent StopCaptureEvent;
var float IconMinDrawScale;
var float IconMaxDrawScale;
var float DistForMinIconDrawScale;
var float DistForMaxIconDrawScale;
var() private const float MultipleCaptureMultiplier;
var() private const Vector ParticleSystemOffset;

replication
{
    // Pos:0x000
    if(bNetDirty && Role == ROLE_Authority)
        CountMultiplier, CurrentCapturingTeam, 
        CurrentStateName, bCapturable, 
        bIsGameEnd, isHillActive, 
        timeOnHill_team0, timeOnHill_team1
}

simulated function ReplicatedEvent(name VarName)
{
    // End:0x3A
    if(VarName == 'CurrentStateName')
    {
        // End:0x37
        if(!IsInState(CurrentStateName))
        {
            GotoState(CurrentStateName);
        }
    }
    // End:0x1A9
    else
    {
        // End:0x54
        if(VarName == 'CurrentCapturingTeam')
        {
        }
        // End:0x1A9
        else
        {
            // End:0x92
            if(VarName == 'isHillActive')
            {
                // End:0x85
                if(isHillActive)
                {
                    Activate();
                }
                // End:0x8F
                else
                {
                    Deactivate();
                }
            }
            // End:0x1A9
            else
            {
                // End:0xC3
                if(VarName == 'bCapturable')
                {
                    // End:0xC0
                    if(bCapturable)
                    {
                        ReadyPoint();
                    }
                }
                // End:0x1A9
                else
                {
                    // End:0x13E
                    if((VarName == 'timeOnHill_team0') || VarName == 'timeOnHill_team1')
                    {
                        // End:0x13B
                        if(!IsInState('Uncontrolled'))
                        {
                            CaptureAnimNode.SetPosition(CaptureAnimTime * (GetCaptureRatio()), false);
                        }
                    }
                    // End:0x1A9
                    else
                    {
                        // End:0x196
                        if(VarName == 'CountMultiplier')
                        {
                            CaptureAnimNode.Rate = (CaptureAnimTime / requiredTimeForCapture) * CountMultiplier;
                        }
                        // End:0x1A9
                        else
                        {
                            super(FoxGameObject_Use).ReplicatedEvent(VarName);
                        }
                    }
                }
            }
        }
    }
    //return;    
}

function GetSavedTKOTHStatus()
{
    //return;    
}

simulated event PostBeginPlay()
{
    super(FoxGameObject_Use).PostBeginPlay();
    // End:0x91
    if(Role == ROLE_Authority)
    {
        // End:0x8C
        if(FoxGameMP_TKOTH(WorldInfo.Game) != none)
        {
            FoxGameMP_TKOTH(WorldInfo.Game).RegisterControlPoint(self);
        }
        // End:0x91
        else
        {
            Destroy();
            return;
        }
    }
    CaptureAnimNode = AnimNodeSequence(SkeletalMeshComponent(ObjectMesh).FindAnimNode('Animation'));
    CaptureAnimNode.SetPosition(0.0, false);
    CaptureAnimTime = CaptureAnimNode.GetAnimPlaybackLength();
    CaptureAnimNode.Rate = CaptureAnimTime / requiredTimeForCapture;
    SkeletalMeshComponent(ObjectMesh).AttachComponent(BeaconPSComp, 'Root', ParticleSystemOffset);
    SkeletalMeshComponent(ObjectMesh).AttachComponent(BeaconRingsPSComp, 'Root');
    SkeletalMeshComponent(ObjectMesh).AttachComponentToSocket(BlinkingAllyLFComp, 's_top');
    SkeletalMeshComponent(ObjectMesh).AttachComponentToSocket(BlinkingFoeLFComp, 's_top');
    SkeletalMeshComponent(ObjectMesh).AttachComponentToSocket(AllyCaptLFComp, 's_top');
    SkeletalMeshComponent(ObjectMesh).AttachComponentToSocket(FoeCaptLFComp, 's_top');
    // End:0x2DE
    if(Role == ROLE_Authority)
    {
        GetSavedTKOTHStatus();
    }
    //return;    
}

simulated function bool CanInteractWith(FoxPawn InteractingPawn)
{
    return false;
    //return ReturnValue;    
}

simulated function Tick(float DeltaTime)
{
    super(Actor).Tick(DeltaTime);
    UpdateState(DeltaTime);
    //return;    
}

simulated function FoxGameObject_HillPoint Activate()
{
    local FoxPC PC;
    local FoxPawn P;
    local int bOnOwningTeam;

    isHillActive = true;
    // End:0xC2
    foreach LocalPlayerControllers(class'FoxPC', PC)
    {
        // End:0xC1
        if(PC.myHUD != none)
        {
            PC.myHUD.AddPostRenderedActor(self);
            FoxHudTKOTH(PC.myHUD).NotifyPointActive();
        }        
    }    
    // End:0x141
    if(Role == ROLE_Authority)
    {
        // End:0x140
        foreach WorldInfo.AllPawns(class'FoxPawn', P)
        {
            // End:0x13F
            if(IsPawnInRadius(P, bOnOwningTeam))
            {
                PawnEnteredUseVolume(P);
            }            
        }        
    }
    // End:0x186
    if(CaptureAnimNode != none)
    {
        CaptureAnimNode.SetPosition(CaptureAnimTime * (GetCaptureRatio()), false);
    }
    return self;
    //return ReturnValue;    
}

simulated function Deactivate()
{
    local FoxPC PC;

    isHillActive = false;
    ToggleHRVEffects(false);
    // End:0x90
    foreach LocalPlayerControllers(class'FoxPC', PC)
    {
        // End:0x8F
        if(PC.myHUD != none)
        {
            PC.myHUD.RemovePostRenderedActor(self);
        }        
    }    
    UpdateEffectStates();
    //return;    
}

simulated event Destroyed()
{
    local PlayerController PC;

    // End:0x79
    foreach LocalPlayerControllers(class'PlayerController', PC)
    {
        // End:0x78
        if(PC.myHUD != none)
        {
            PC.myHUD.RemovePostRenderedActor(self);
        }        
    }    
    super(FoxGameObject).Destroyed();
    //return;    
}

function bool IsPawnInRadius(Pawn P, out int bOnOwningTeam)
{
    local int whoIsOnTheHillInfoIndex, PawnIndex;

    // End:0x11
    if(P == none)
    {
        return false;
    }
    bOnOwningTeam = 0;
    whoIsOnTheHillInfoIndex = 0;
    J0x27:
    // End:0x10A [Loop If]
    if(whoIsOnTheHillInfoIndex < 2)
    {
        PawnIndex = 0;
        J0x42:
        // End:0xFC [Loop If]
        if(PawnIndex < whoIsOnTheHillInfo[whoIsOnTheHillInfoIndex].PRIs.Length)
        {
            // End:0xEE
            if(P.PlayerReplicationInfo == whoIsOnTheHillInfo[whoIsOnTheHillInfoIndex].PRIs[PawnIndex])
            {
                // End:0xEC
                if(whoIsOnTheHillInfoIndex == CurrentCapturingTeam)
                {
                    bOnOwningTeam = 1;
                }
                return true;
            }
            ++ PawnIndex;
            // [Loop Continue]
            goto J0x42;
        }
        ++ whoIsOnTheHillInfoIndex;
        // [Loop Continue]
        goto J0x27;
    }
    return false;
    //return ReturnValue;    
}

simulated function PawnEnteredUseVolume(Pawn EnteringPawn)
{
    local FoxPawn FP;
    local int TeamNum;
    local FoxPRI PRI;

    // End:0x1A
    if(FoxVehicle(EnteringPawn) != none)
    {
        return;
    }
    FP = FoxPawn(EnteringPawn);
    // End:0xB2
    if(((FP == none) || FP.PlayerReplicationInfo == none) || FoxPRI(FP.PlayerReplicationInfo).IsValidPlayer() == false)
    {
        return;
    }
    PRI = FoxPRI(FP.PlayerReplicationInfo);
    TeamNum = FP.GetTeamNum();
    // End:0x174
    if((TeamNum == 255) || whoIsOnTheHillInfo[TeamNum].PRIs.Find(FP.PlayerReplicationInfo) != -1)
    {
        return;
    }
    FP.StartUseInterval(FoxGRI(WorldInfo.GRI).GetIntervalForEvent(11));
    // End:0x359
    if(Role == ROLE_Authority)
    {
        whoIsOnTheHillInfo[TeamNum].PRIs.AddItem(PRI);
        // End:0x359
        if(whoWasOnTheHillInfo[TeamNum].PRIs.Find(PRI) == -1)
        {
            whoWasOnTheHillInfo[TeamNum].PRIs.AddItem(PRI);
            FoxOnlineStatsWriteGameTypeTKOTH(PRI.GameTypeStats).StartTimeCapturing(WorldInfo.RealTimeSeconds);
            FoxGame(WorldInfo.Game).BroadcastPawnUseDialog(4,, byte(PRI.Team.TeamIndex));
        }
    }
    super.PawnEnteredUseVolume(EnteringPawn);
    //return;    
}

simulated function PawnLeavingUseVolume(Pawn LeavingPawn)
{
    local FoxPawn FP;
    local FoxPRI PRI;
    local int I;

    FP = FoxPawn(LeavingPawn);
    // End:0x164
    if(FP != none)
    {
        PRI = FoxPRI(LeavingPawn.PlayerReplicationInfo);
        // End:0x164
        if(Role == ROLE_Authority)
        {
            I = 0;
            J0x7B:
            // End:0x164 [Loop If]
            if(I < 2)
            {
                // End:0x156
                if(whoIsOnTheHillInfo[I].PRIs.Find(PRI) != -1)
                {
                    whoIsOnTheHillInfo[I].PRIs.RemoveItem(PRI);
                    FoxOnlineStatsWriteGameTypeTKOTH(PRI.GameTypeStats).StopTimeCapturing(WorldInfo.RealTimeSeconds);
                }
                ++ I;
                // [Loop Continue]
                goto J0x7B;
            }
        }
    }
    super.PawnLeavingUseVolume(LeavingPawn);
    //return;    
}

// Export UFoxGameObject_HillPoint::execGetCurrentCapturingTeam(FFrame&, void* const)
native function int GetCurrentCapturingTeam();

simulated function FoxTeamInfo GetControllingTeam()
{
    // End:0x5A
    if(CurrentCapturingTeam != -1)
    {
        return FoxTeamInfo(WorldInfo.GRI.Teams[CurrentCapturingTeam]);
    }
    return none;
    //return ReturnValue;    
}

function FoxTeamInfo GetWinningTeamByTime()
{
    local int WinningTeam;

    WinningTeam = ((timeOnHill_team0 > timeOnHill_team1) ? 0 : 1);
    return FoxTeamInfo(WorldInfo.GRI.Teams[WinningTeam]);
    //return ReturnValue;    
}

function int DominantTeamPawnDifference(optional out int dominantTeam)
{
    local int pawnCountDifference;

    pawnCountDifference = (GetNumActiveCapturingPawnsForTeam(0)) - (GetNumActiveCapturingPawnsForTeam(1));
    // End:0x40
    if(pawnCountDifference > 0)
    {
        dominantTeam = 0;
    }
    // End:0x81
    else
    {
        // End:0x72
        if(pawnCountDifference < 0)
        {
            dominantTeam = 1;
            pawnCountDifference = -pawnCountDifference;
        }
        // End:0x81
        else
        {
            dominantTeam = -1;
        }
    }
    return pawnCountDifference;
    //return ReturnValue;    
}

function int GetNumActiveCapturingPawnsForTeam(int TeamIndex)
{
    local int I, Result;

    I = 0;
    J0x0B:
    // End:0x165 [Loop If]
    if(I < whoIsOnTheHillInfo[TeamIndex].PRIs.Length)
    {
        // End:0x157
        if(((whoIsOnTheHillInfo[TeamIndex].PRIs[I].Owner != none) && FoxPC(whoIsOnTheHillInfo[TeamIndex].PRIs[I].Owner) != none) && FoxPC(whoIsOnTheHillInfo[TeamIndex].PRIs[I].Owner).MyFoxPawn != none)
        {
            ++ Result;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    return Result;
    //return ReturnValue;    
}

// Export UFoxGameObject_HillPoint::execGetCaptureRatio(FFrame&, void* const)
native simulated function float GetCaptureRatio(optional out int Team);

// Export UFoxGameObject_HillPoint::execGetTeamCaptureRatio(FFrame&, void* const)
native simulated function float GetTeamCaptureRatio(int teamNumber);

// Export UFoxGameObject_HillPoint::execGetTeamCaptureTime(FFrame&, void* const)
native simulated function float GetTeamCaptureTime(int teamNumber);

simulated event byte ScriptGetTeamNum()
{
    // End:0x1F
    if(CurrentCapturingTeam > -1)
    {
        return byte(CurrentCapturingTeam);
    }
    return 255;
    //return ReturnValue;    
}

function bool UpdateTeamHillTime(float DT, optional out int TeamIndex)
{
    // End:0xDE
    if(0 != (DominantTeamPawnDifference(TeamIndex)))
    {
        CountMultiplier = Abs(float((GetNumActiveCapturingPawnsForTeam(0)) - (GetNumActiveCapturingPawnsForTeam(1)))) * MultipleCaptureMultiplier;
        CaptureAnimNode.Rate = (CaptureAnimTime / requiredTimeForCapture) * CountMultiplier;
        // End:0xBA
        if(TeamIndex == 0)
        {
            timeOnHill_team0 += (DT * CountMultiplier);
        }
        // End:0xD9
        else
        {
            timeOnHill_team1 += (DT * CountMultiplier);
        }
        return true;
    }
    // End:0xE0
    else
    {
        return false;
    }
    //return ReturnValue;    
}

simulated function bool IsPlayerOnControllingTeam()
{
    local PlayerController PC;

    // End:0x22
    if((CurrentCapturingTeam != 0) && CurrentCapturingTeam != 1)
    {
        return false;
    }
    PC = GetALocalPlayerController();
    // End:0xA8
    if(((PC == none) || PC.PlayerReplicationInfo == none) || PC.PlayerReplicationInfo.Team == none)
    {
        return false;
    }
    return (CurrentCapturingTeam == PC.PlayerReplicationInfo.Team.TeamIndex) || (CurrentCapturingTeam == 0) && PC.PlayerReplicationInfo.bOnlySpectator;
    //return ReturnValue;    
}

simulated function AnnounceCapture()
{
    local PlayerController PC;
    local int PCTeamNum;
    local FoxHudTKOTH HUD;

    // End:0x1B3
    if((CurrentCapturingTeam > -1) && CurrentCapturingTeam < 2)
    {
        PC = GetALocalPlayerController();
        // End:0xAB
        if(((PC == none) || PC.PlayerReplicationInfo == none) || PC.PlayerReplicationInfo.Team == none)
        {
            return;
        }
        PCTeamNum = PC.PlayerReplicationInfo.Team.TeamIndex;
        // End:0x15B
        if(FoxHudTKOTH(PC.myHUD) != none)
        {
            HUD = FoxHudTKOTH(PC.myHUD);
        }
        // End:0x194
        if(CurrentCapturingTeam == PCTeamNum)
        {
            HUD.NotifyPointCaptured();
        }
        // End:0x1B3
        else
        {
            HUD.NotifyPointCaptureFail();
        }
    }
    //return;    
}

simulated function AnimationTimer_InitiateCapturedCoolDown()
{
    SetTimer(CapturedPSFadeTime - CaptureAnimTime, false, 'AnimationTimer_StartCoolDown');
    //return;    
}

simulated function AnimationTimer_StartCoolDown()
{
    CaptureAnimNode.Rate = -CaptureAnimTime;
    CaptureAnimNode.SetPosition(-CaptureAnimTime, false);
    CaptureAnimNode.ReplayAnim();
    SetTimer(CaptureAnimTime, false, 'AnimationTimer_EndCoolDown');
    //return;    
}

simulated function AnimationTimer_EndCoolDown()
{
    CaptureAnimNode.StopAnim();
    CaptureAnimNode.SetPosition(0.0, false);
    CaptureAnimNode.Rate = CaptureAnimTime / requiredTimeForCapture;
    //return;    
}

function CapturingTimer()
{
    local FoxGRI_TKOTH GRI;

    GRI = FoxGRI_TKOTH(WorldInfo.GRI);
    // End:0x86
    if(GRI != none)
    {
        AddPointsToCapturingTeam(class<FoxScoringInfoTKOTH>(GRI.ScoringInfoClass).default.ExpTeamScoreInterval);
    }
    //return;    
}

function AddPointsToCapturingTeam(int Amount)
{
    local FoxPC PC;
    local FoxPRI PRI;

    // End:0x12C
    if(((CurrentCapturingTeam >= 0) && !WorldInfo.Game.bGameEnded) && true == isHillActive)
    {
        // End:0x12B
        foreach WorldInfo.AllControllers(class'FoxPC', PC)
        {
            PRI = FoxPRI(PC.PlayerReplicationInfo);
            // End:0x12A
            if(PRI.Team.TeamIndex == CurrentCapturingTeam)
            {
                PRI.AddExperience(Amount);
            }            
        }        
    }
    //return;    
}

simulated function UpdateEffectStates()
{
    local Color PSColor;
    local bool bIsOnControllingTeam;

    bIsOnControllingTeam = IsPlayerOnControllingTeam();
    BeaconPSComp.DeactivateSystem();
    BeaconPSComp.SetHidden(true);
    BeaconPSComp.KillParticlesForced();
    BeaconRingsPSComp.DeactivateSystem();
    BeaconRingsPSComp.SetHidden(true);
    BeaconRingsPSComp.KillParticlesForced();
    BlinkingAllyLFComp.SetIsActive(false);
    BlinkingAllyLFComp.SetHidden(true);
    BlinkingFoeLFComp.SetIsActive(false);
    BlinkingFoeLFComp.SetHidden(true);
    AllyCaptLFComp.SetIsActive(false);
    AllyCaptLFComp.SetHidden(true);
    FoeCaptLFComp.SetIsActive(false);
    FoeCaptLFComp.SetHidden(true);
    // End:0x1F1
    if(bIsGameEnd || !isHillActive)
    {
        return;
    }
    // End:0x22C
    if(bIsOnControllingTeam == true)
    {
        PSColor = class'FoxTeamInfo'.default.FriendlyTeamColor;
    }
    // End:0x254
    else
    {
        PSColor = class'FoxTeamInfo'.default.EnemyTeamColor;
    }
    // End:0x3E7
    if(bHRVIsEnabled)
    {
        // End:0x35D
        if(CurrentStateName == 'Capturing')
        {
            BeaconPSComp.SetColorParameter(CapturedParticleSystemColorParamName, PSColor);
            BeaconPSComp.ActivateSystem(false);
            BeaconPSComp.SetHidden(false);
            BeaconRingsPSComp.SetColorParameter(CapturedParticleSystemColorParamName, PSColor);
            BeaconRingsPSComp.ActivateSystem(false);
            BeaconRingsPSComp.SetHidden(false);
        }
        // End:0x3E5
        else
        {
            // End:0x3E5
            if(CurrentStateName == 'Captured')
            {
                BeaconPSComp.SetColorParameter(CapturedParticleSystemColorParamName, PSColor);
                BeaconPSComp.ActivateSystem(false);
                BeaconPSComp.SetHidden(false);
            }
        }
        return;
    }
    // End:0x494
    if(CurrentStateName == 'Capturing')
    {
        // End:0x451
        if(bIsOnControllingTeam == true)
        {
            BlinkingAllyLFComp.SetIsActive(true);
            BlinkingAllyLFComp.SetHidden(false);
        }
        // End:0x491
        else
        {
            BlinkingFoeLFComp.SetIsActive(true);
            BlinkingFoeLFComp.SetHidden(false);
        }
    }
    // End:0x53E
    else
    {
        // End:0x53E
        if(CurrentStateName == 'Captured')
        {
            // End:0x4FE
            if(bIsOnControllingTeam == true)
            {
                AllyCaptLFComp.SetIsActive(false);
                AllyCaptLFComp.SetHidden(true);
            }
            // End:0x53E
            else
            {
                FoeCaptLFComp.SetIsActive(false);
                FoeCaptLFComp.SetHidden(true);
            }
        }
    }
    //return;    
}

// Export UFoxGameObject_HillPoint::execGetControlColor(FFrame&, void* const)
native simulated function LinearColor GetControlColor();

simulated function ToggleHRVEffects(const bool bHRVEnabled)
{
    local FoxPC PC;
    local bool oldHRVState;

    super.ToggleHRVEffects(bHRVEnabled);
    // End:0x9E
    if(isHillActive == false)
    {
        // End:0x9D
        foreach LocalPlayerControllers(class'FoxPC', PC)
        {
            // End:0x9C
            if(PC.myHUD != none)
            {
                PC.myHUD.RemovePostRenderedActor(self);
            }            
        }        
    }
    // End:0xBE
    if(!isHillActive && bHRVEnabled)
    {
        return;
    }
    oldHRVState = bHRVIsEnabled;
    bHRVIsEnabled = bHRVEnabled;
    // End:0x10B
    if(oldHRVState != bHRVEnabled)
    {
        UpdateEffectStates();
    }
    //return;    
}

simulated function NotifyUseObjectInterval(FoxPawn Pawn)
{
    //return;    
}

simulated function UpdateState(float DT)
{
    //return;    
}

simulated function ReadyPoint()
{
    local FoxPC PC;

    bCapturable = true;
    // End:0x8D
    foreach LocalPlayerControllers(class'FoxPC', PC)
    {
        // End:0x8C
        if(PC.myHUD != none)
        {
            FoxHudTKOTH(PC.myHUD).NotifyPointCapturable();
        }        
    }    
    //return;    
}

auto simulated state Uncontrolled
{
    ignores EndState, OnSuccessfulUse;

    simulated function BeginState(name PreviousStateName)
    {
        // End:0x7D
        if(Role == ROLE_Authority)
        {
            // End:0x55
            if(PreviousStateName != 'Capturing')
            {
                timeOnHill_team0 = 0.0;
                timeOnHill_team1 = 0.0;
                bForceNetUpdate = true;
            }
            CurrentCapturingTeam = -1;
            CurrentStateName = GetStateName();
            bForceNetUpdate = true;
        }
        UpdateEffectStates();
        //return;        
    }

    simulated function UpdateState(float DT)
    {
        local int TeamIndex;

        TeamIndex = -1;
        global.UpdateState(DT);
        // End:0x92
        if(Role == ROLE_Authority)
        {
            // End:0x58
            if(!isHillActive || !bCapturable)
            {
                return;
            }
            // End:0x92
            if(0 != (DominantTeamPawnDifference(TeamIndex)))
            {
                CurrentCapturingTeam = TeamIndex;
                GotoState('Capturing');
            }
        }
        //return;        
    }
    stop;    
}

simulated state Capturing
{
    ignores OnSuccessfulUse;

    simulated function BeginState(name PreviousStateName)
    {
        local FoxGRI_TKOTH GRI;

        // End:0xCB
        if(Role == ROLE_Authority)
        {
            // End:0x26
            if(false == isHillActive)
            {
                return;
            }
            GRI = FoxGRI_TKOTH(WorldInfo.GRI);
            CurrentStateName = GetStateName();
            bForceNetUpdate = true;
            // End:0xCB
            if(GRI != none)
            {
                SetTimer(float(class<FoxScoringInfoTKOTH>(GRI.ScoringInfoClass).default.TeamScoreInterval), true, 'CapturingTimer');
            }
        }
        UpdateEffectStates();
        PlayAkEvent(StartCaptureEvent, true);
        //return;        
    }

    simulated function NotifyUseObjectInterval(FoxPawn Pawn)
    {
        // End:0x210
        if((((((Pawn != none) && Pawn.IsAliveAndWell()) && !Pawn.IsInjured()) && isHillActive) && Pawn.PlayerReplicationInfo != none) && bIsGameEnd == false)
        {
            // End:0x130
            if(Role == ROLE_Authority)
            {
                FoxPRI(Pawn.PlayerReplicationInfo).AddExperience(FoxGRI(WorldInfo.GRI).GetScoreForEvent(11));
            }
            // End:0x210
            if((Pawn.IsLocallyControlled() && Pawn.Controller != none) && FoxPC(Pawn.Controller).MyFoxHud != none)
            {
                FoxPC(Pawn.Controller).MyFoxHud.AddNewPassivePointNotification(11);
            }
        }
        //return;        
    }

    simulated function EndState(name NextStateName)
    {
        CaptureAnimNode.StopAnim();
        ClearTimer('CapturingTimer');
        PlayAkEvent(StopCaptureEvent, true);
        //return;        
    }

    simulated function UpdateState(float DT)
    {
        global.UpdateState(DT);
        // End:0x25
        if(false == isHillActive)
        {
            return;
        }
        // End:0xA3
        if(Role == ROLE_Authority)
        {
            // End:0x63
            if(false == (UpdateTeamHillTime(DT)))
            {
                GotoState('Uncontrolled');
                return;
            }
            // End:0xA3
            if((timeOnHill_team0 >= requiredTimeForCapture) || timeOnHill_team1 >= requiredTimeForCapture)
            {
                GotoState('Captured');
                return;
            }
        }
        // End:0x145
        if(CaptureAnimNode.bPlaying == false)
        {
            // End:0x145
            if(((timeOnHill_team0 >= timeOnHill_team1) ? 0 : 1) == CurrentCapturingTeam)
            {
                CaptureAnimNode.PlayAnim(false, CaptureAnimNode.Rate, CaptureAnimTime * (GetCaptureRatio()));
            }
        }
        //return;        
    }
    stop;    
}

simulated state Captured
{
    ignores OnSuccessfulUse;

    simulated function BeginState(name PreviousStateName)
    {
        local int I;
        local FoxPRI PRI;

        // End:0x12
        if(false == isHillActive)
        {
            return;
        }
        // End:0x487
        if(Role == ROLE_Authority)
        {
            bCapturable = false;
            CurrentStateName = GetStateName();
            bForceNetUpdate = true;
            // End:0x62
            if(timeOnHill_team0 == timeOnHill_team1)
            {
            }
            I = 0;
            J0x6D:
            // End:0x1FA [Loop If]
            if(I < whoIsOnTheHillInfo[CurrentCapturingTeam].PRIs.Length)
            {
                PRI = whoIsOnTheHillInfo[CurrentCapturingTeam].PRIs[I];
                // End:0x1EC
                if((((PRI != none) && PRI.Owner != none) && FoxPC(PRI.Owner) != none) && FoxPC(PRI.Owner).MyFoxPawn != none)
                {
                    ++ PRI.NumGameCaptures;
                    FoxGameMP_TKOTH(WorldInfo.Game).ScoreEvent(PRI, 8);
                }
                ++ I;
                // [Loop Continue]
                goto J0x6D;
            }
            I = 0;
            J0x205:
            // End:0x373 [Loop If]
            if(I < whoWasOnTheHillInfo[CurrentCapturingTeam].PRIs.Length)
            {
                PRI = whoWasOnTheHillInfo[CurrentCapturingTeam].PRIs[I];
                // End:0x365
                if(PRI != none)
                {
                    // End:0x345
                    if(whoIsOnTheHillInfo[CurrentCapturingTeam].PRIs.Find(PRI) == -1)
                    {
                        FoxGameMP_TKOTH(WorldInfo.Game).ScoreEvent(PRI, 9);
                        PRI.AddExperience(class'FoxScoringInfoTKOTH'.default.ExpPointCaptureAssist);
                    }
                    ++ PRI.NumPointCaptures;
                }
                ++ I;
                // [Loop Continue]
                goto J0x205;
            }
            FoxGame(WorldInfo.Game).DirtyThreatFlag(CurrentCapturingTeam);
            FoxGame(WorldInfo.Game).bVIPDirty = true;
            AnnounceCapture();
            FoxGameMP_TKOTH(WorldInfo.Game).ScoreHillCapture();
            bIsGameEnd = FoxGameMP_TKOTH(WorldInfo.Game).IsGameEnd();
        }
        // End:0x515
        if(false == bIsGameEnd)
        {
            captureCoolDown = CapturedPSFadeTime;
            AnimationTimer_InitiateCapturedCoolDown();
            // End:0x515
            if(WorldInfo.Game != none)
            {
                FoxGameMP_TKOTH(WorldInfo.Game).ChooseNextPoint();
            }
        }
        UpdateEffectStates();
        //return;        
    }

    simulated function EndState(name NextStateName)
    {
        local int I;

        // End:0x27
        if(!bIsGameEnd)
        {
            PlayAkEvent(CompleteCaptureEvent, true);
        }
        TriggerEventClass(class'FoxSeqEvent_Captured', self);
        // End:0x52
        if(Role == ROLE_Authority)
        {
        }
        I = 0;
        J0x5D:
        // End:0xCD [Loop If]
        if(I < 2)
        {
            whoWasOnTheHillInfo[I].PRIs.Length = 0;
            whoIsOnTheHillInfo[I].PRIs.Length = 0;
            ++ I;
            // [Loop Continue]
            goto J0x5D;
        }
        //return;        
    }
    stop;    
}

defaultproperties
{
    requiredTimeForCapture=60.0
    CurrentCapturingTeam=-1
    begin object name=PSC_Beacon class=ParticleSystemComponent
        ReplacementPrimitive=none
        DepthPriorityGroup=ESceneDepthPriorityGroup.SDPG_Foreground
    object end
    // Reference: ParticleSystemComponent'Default__FoxGameObject_HillPoint.PSC_Beacon'
    BeaconPSComp=PSC_Beacon
    begin object name=PSC_BeaconRings class=ParticleSystemComponent
        ReplacementPrimitive=none
        DepthPriorityGroup=ESceneDepthPriorityGroup.SDPG_Foreground
    object end
    // Reference: ParticleSystemComponent'Default__FoxGameObject_HillPoint.PSC_BeaconRings'
    BeaconRingsPSComp=PSC_BeaconRings
    begin object name=LF_BlinkingAlly class=LensFlareComponent
        bAutoActivate=false
        NextTraceTime=-0.21860410
        ReplacementPrimitive=none
    object end
    // Reference: LensFlareComponent'Default__FoxGameObject_HillPoint.LF_BlinkingAlly'
    BlinkingAllyLFComp=LF_BlinkingAlly
    begin object name=LF_BlinkingFoe class=LensFlareComponent
        bAutoActivate=false
        NextTraceTime=-0.32975250
        ReplacementPrimitive=none
    object end
    // Reference: LensFlareComponent'Default__FoxGameObject_HillPoint.LF_BlinkingFoe'
    BlinkingFoeLFComp=LF_BlinkingFoe
    begin object name=LF_Ally_Capt class=LensFlareComponent
        bAutoActivate=false
        NextTraceTime=-0.2728660
        ReplacementPrimitive=none
    object end
    // Reference: LensFlareComponent'Default__FoxGameObject_HillPoint.LF_Ally_Capt'
    AllyCaptLFComp=LF_Ally_Capt
    begin object name=LF_Foe_Capt class=LensFlareComponent
        bAutoActivate=false
        NextTraceTime=-0.56270030
        ReplacementPrimitive=none
    object end
    // Reference: LensFlareComponent'Default__FoxGameObject_HillPoint.LF_Foe_Capt'
    FoeCaptLFComp=LF_Foe_Capt
    CaptureParticleSystemAttachSocketName=s_top
    TeamColorParameterName=TeamColor
    CaptureAmountParameterName=CaptureAmount
    CapturedParticleSystemColorParamName=Color
    CapturedPSFadeTime=5.0
    IconMinDrawScale=64.0
    IconMaxDrawScale=256.0
    DistForMinIconDrawScale=2500.0
    DistForMaxIconDrawScale=500.0
    MultipleCaptureMultiplier=1.20
    begin object name=NewHillMesh class=SkeletalMeshComponent
        ReplacementPrimitive=none
        LightEnvironment=DynamicLightEnvironmentComponent'Default__FoxGameObject_HillPoint.MyLightEnvironment'
        RBChannel=ERBCollisionChannel.RBCC_GameplayPhysics
        CollideActors=true
        BlockActors=true
        BlockZeroExtent=true
        BlockNonZeroExtent=true
        BlockRigidBody=true
        RBCollideWithChannels=(Default=true,GameplayPhysics=true,EffectPhysics=true,BlockingVolume=true)
    object end
    // Reference: SkeletalMeshComponent'Default__FoxGameObject_HillPoint.NewHillMesh'
    ObjectMesh=NewHillMesh
    Components(0)=none
    begin object name=PSC_Beacon class=ParticleSystemComponent
        ReplacementPrimitive=none
        DepthPriorityGroup=ESceneDepthPriorityGroup.SDPG_Foreground
    object end
    // Reference: ParticleSystemComponent'Default__FoxGameObject_HillPoint.PSC_Beacon'
    Components(1)=PSC_Beacon
    begin object name=PSC_BeaconRings class=ParticleSystemComponent
        ReplacementPrimitive=none
        DepthPriorityGroup=ESceneDepthPriorityGroup.SDPG_Foreground
    object end
    // Reference: ParticleSystemComponent'Default__FoxGameObject_HillPoint.PSC_BeaconRings'
    Components(2)=PSC_BeaconRings
    begin object name=LF_BlinkingAlly class=LensFlareComponent
        bAutoActivate=false
        NextTraceTime=-0.21860410
        ReplacementPrimitive=none
    object end
    // Reference: LensFlareComponent'Default__FoxGameObject_HillPoint.LF_BlinkingAlly'
    Components(3)=LF_BlinkingAlly
    begin object name=LF_BlinkingFoe class=LensFlareComponent
        bAutoActivate=false
        NextTraceTime=-0.32975250
        ReplacementPrimitive=none
    object end
    // Reference: LensFlareComponent'Default__FoxGameObject_HillPoint.LF_BlinkingFoe'
    Components(4)=LF_BlinkingFoe
    begin object name=LF_Ally_Capt class=LensFlareComponent
        bAutoActivate=false
        NextTraceTime=-0.2728660
        ReplacementPrimitive=none
    object end
    // Reference: LensFlareComponent'Default__FoxGameObject_HillPoint.LF_Ally_Capt'
    Components(5)=LF_Ally_Capt
    begin object name=LF_Foe_Capt class=LensFlareComponent
        bAutoActivate=false
        NextTraceTime=-0.56270030
        ReplacementPrimitive=none
    object end
    // Reference: LensFlareComponent'Default__FoxGameObject_HillPoint.LF_Foe_Capt'
    Components(6)=LF_Foe_Capt
    Components(7)=DynamicLightEnvironmentComponent'Default__FoxGameObject_HillPoint.MyLightEnvironment'
    begin object name=NewHillMesh class=SkeletalMeshComponent
        ReplacementPrimitive=none
        LightEnvironment=DynamicLightEnvironmentComponent'Default__FoxGameObject_HillPoint.MyLightEnvironment'
        RBChannel=ERBCollisionChannel.RBCC_GameplayPhysics
        CollideActors=true
        BlockActors=true
        BlockZeroExtent=true
        BlockNonZeroExtent=true
        BlockRigidBody=true
        RBCollideWithChannels=(Default=true,GameplayPhysics=true,EffectPhysics=true,BlockingVolume=true)
    object end
    // Reference: SkeletalMeshComponent'Default__FoxGameObject_HillPoint.NewHillMesh'
    Components(8)=NewHillMesh
    bCollideActors=true
    bCollideWorld=true
    bBlockActors=true
    bNoEncroachCheck=true
    SupportedEvents=/* Array type was not detected. */
}